; LevelEditor

Global Px,Py,Light#=1,r2#,b2#,c2#,Selected=0
Dim Mc$(25)
Dim Mr(25)
Dim Mg(25)
Dim Mb(25)
For x=1 To 25
mr(x)=255
mg(x)=255
mb(x)=255
Next
Mc(1)="#":Mr(1)=128:Mg(1)=128:Mb(1)=128
Mc(2)=">":Mg(2)=0:Mb(2)=0
Mc(3)="^":Mg(3)=0:Mb(3)=0
Mc(4)="<":Mg(4)=0:Mb(4)=0
Mc(5)="v":Mg(5)=0:Mb(5)=0
Mc(6)="*":Mr(6)=0:Mg(6)=0
Mc(7)="/"
Mc(8)="\"
Mc(10)="A":Mr(10)=128:Mg(10)=0:Mb(10)=0
Mc(11)="A":Mb(11)=0
Mc(12)="A":Mr(12)=100:Mg(12)=0:Mb(12)=100
Mc(13)="A":Mr(13)=-2
Mc(14)="B":Mr(14)=128:Mg(14)=0:Mb(14)=0
Mc(15)="B":Mb(15)=0
Mc(16)="B":Mr(16)=100:Mg(16)=0:Mb(16)=100
Mc(17)="B":Mr(17)=-2
Mc(18)="C":Mr(18)=128:Mg(18)=0:Mb(18)=0
Mc(19)="C":Mb(19)=0
Mc(20)="C":Mr(20)=100:Mg(20)=0:Mb(20)=100
Mc(21)="C":Mr(21)=-2
Mc(22)="?":Mr(22)=128:Mg(22)=0:Mb(22)=0
Mc(23)="?":Mb(23)=0
Mc(24)="?":Mr(24)=100:Mg(24)=0:Mb(24)=100
Mc(25)="?":Mr(25)=-2
Dim Map(39,19)
Dim lMap(39,19)

Const MaxWorlds% = 100

Global level = 1
Global world = 1

Setup()
Game()
End

Function Setup()
	Graphics 800,600,16,2
	SetBuffer BackBuffer()
	SetFont LoadFont("Courier",30)
	LVLFile=ReadFile("LevelPacks/basic.lvlp")
	HidePointer
End Function

Function Game()
	While Not KeyHit(1)
		ms=MilliSecs()
		r2=Light*255.0*(Sin(.3*ms)+1)/2
		g2=Light*255.0*(Sin(.3*ms+120)+1)/2
		b2=Light*255.0*(Sin(.3*ms+240)+1)/2
		
		If KeyHit(31) Then
			
			ResFile = WriteFile("Levelpacks/level_" + world + "_" + level + ".lvlp")
			
			WriteByte ResFile, px
			WriteByte ResFile, py
			
			For y = 0 To 19
				
				For x = 0 To 39
					
					WriteByte ResFile, Map(x,y)
					
				Next
				
			Next
			CloseFile ResFile
			
		EndIf
		
		If KeyHit(38) Then
			
			If FileType("Levelpacks/level_" + world + "_" + level + ".lvlp")=1 Then
				
				LvlFile = ReadFile("Levelpacks/level_" + world + "_" + level + ".lvlp")
				Px=ReadByte(LVLFile)
				Py=ReadByte(LVLFile)
				
				For y=0 To 19
					
					For x=0 To 39
						
						Map(x,y)=ReadByte(LVLFile)
						
					Next
					
				Next
				
			EndIf
			
		EndIf
		
		If KeyHit(25) Then
			
			xworld = world
			xlevel = level
			
			world = 1
			level = 1
			
			Cls
			Color 255, 255, 255
			While world <= MaxWorlds
				
				level = 1
				strFile$ = "levelpacks/level_" + world + "_" + level + ".lvlp"
				While FileType(strFile) = 1
					
					If Not fileWorld Then
						fileWorld = WriteFile("levelpacks/world_" + world + ".lvlp")
						Print "Writing world " + world + "..."
					EndIf
					Print "..." + strFile
					File = ReadFile(strFile)
					
					For byte = 1 To 40*20+2
						
						WriteByte fileworld, ReadByte(File)
						
					Next
					
					level = level + 1
					strFile$ = "levelpacks/level_" + world + "_" + level + ".lvlp"
					
				Wend
				
				If fileWorld Then
					
					CloseFile fileworld
					Print "Written " + (level - 1) + " levels"
					
				EndIf
				fileWorld = 0
				world = world + 1
				
			Wend
			
			world = xworld
			level = xlevel
			
			Print "Done!"
			Print "Press any key..."
			WaitKey
			
		EndIf
		
		For x=0 To 39
			For y=0 To 19
				LMap(x,y)=0
			Next
		Next
		
		For x=0 To 39
			For y=0 To 19
				z=Map(x,y)
				If z Then Txt(x,y,Mc(z),Mr(z),Mg(z),Mb(z))
				If z=2 laser(x,y,1,0)
				If z=3 laser(x,y,0,-1)
				If z=4 laser(x,y,-1,0)
				If z=5 laser(x,y,0,1)
				If z>6 win=0:TargLight=1
			Next
		Next
		
		Col 255,0,0
		For x=0 To 39
			For y=0 To 19
				If LMap(x,y) = 1 Then Txt(x,y,"-")
				If LMap(x,y) = 2 Then Txt(x,y,"|")
				If LMap(x,y) > 2 Then Txt(x,y,"+")
			Next
		Next
		
		Txt(Px,Py,"X",0,255,0)
		
		Col 255,255,255
		Text 400,30,"World:" + World,1,1
		Text 400,60,"Level:" + Level,1,1
		If selected=0 Then
			Text 400,90,"Selected: Player",1,1
		Else
			Text 400,90,"Selected: " + Mc(selected),1,1
		EndIf
		
		level = level + KeyHit(200) - KeyHit(208)
		world = world + KeyHit(205) - KeyHit(203)
		
		mx = (MouseX()-100)/15
		my = (MouseY()-120)/18
		
		Selected = Selected + MouseZSpeed() + KeyHit(3) - KeyHit(2)
		
		If Selected < 0 Then Selected = 25
		If Selected > 25 Then Selected = 0
		
		If (mx>=0)And(mx<40)And(my>=0)And(my<20) Then
			
			HidePointer
			
			Rect mx*15 + 98,my*20 + 118,20,25,False
			Txt mx,my,mc(selected),mr(selected),mg(selected),mb(selected)
			
			If MouseDown(1) Then
				
				If Selected = 0 Then
					
					px = mx
					py = my
					
				Else
					
					Map(mx, my) = Selected
					
				EndIf
				
			EndIf
			If MouseDown(2) Then
				
				Map(mx, my) = 0
				
			EndIf
			
		Else
			
			ShowPointer
			
		EndIf
		
		Flip:Cls
	Wend
End Function

Function laser(x,y,dx,dy)
	Color 255*light,0,0
	While 1
		x=x+dx
		y=y+dy
		If ((Map(x,y)<22)And(Map(x,y)>0))And(Not(Map(x,y)=7))And(Not(Map(x,y)=8)) Then Return
		If (x>=0)And(x<40)And(y>=0)And(y<20)
			If Map(x,y)=7 Then a=dx:dx=-dy:dy=-a
			If Map(x,y)=8 Then a=dx:dx=dy:dy=a
		Else
			Return
		EndIf
		If Map(x,y)=0
			If dx<>0
				If LMap(x,y)<2
					LMap(x,y)=1
				Else
					LMap(x,y)=3
				EndIf
			EndIf
			If dy<>0
				If (LMap(x,y)=2) Or (LMap(x,y)=0)
					LMap(x,y)=2
				Else
					LMap(x,y)=3
				EndIf
			EndIf
		EndIf
	Wend
End Function

Function Txt(X,Y,Msg$,R=-1,G=-1,B=-1)
If Msg="" Return
If R<>-1 Then Col(r,g,b)
Text X*15+100,Y*20+120,Msg
End Function

Function Col(r,g,b)
If r=-2
Color r2,g2,b2
Else 
Color Light*R,Light*G,light*B
EndIf
End Function